from enum import Enum

from tortoise import models, fields


class KeyTypes(Enum):
    PASSWORD = "PASSWORD"
    RSA = "RSA"
    ECDSA = "ECDSA"
    Ed25519 = "Ed25519"


class Credential(models.Model):
    owner = fields.ForeignKeyField('models.User', related_name='credentials', on_delete=fields.CASCADE)
    username = fields.CharField(max_length=64)
    key_type = fields.CharEnumField(enum_type=KeyTypes, max_length=16, default=KeyTypes.PASSWORD)
    content = fields.TextField(null=False)
    passphrase = fields.CharField(max_length=128, null=True)
